%global forgeurl https://github.com/PyCQA/pylint
Version:        2.17.4

Name:           pylint
Release:    2%{?dist}
Summary:        Analyzes Python code looking for bugs and signs of poor quality
License:        GPL-2.0-or-later
URL:            https://www.pylint.org/
Source0:        pylint-2.17.4.tar.gz
Patch1:         unpin-astroid.patch
BuildArch:      noarch

BuildRequires:  pyproject-rpm-macros
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-wheel
BuildRequires:  python3-pip
BuildRequires:  python3-py
BuildRequires:  python3-astroid >= 2.12.1
BuildRequires:  python3-dill
BuildRequires:  python3-GitPython
BuildRequires:  python3-isort
BuildRequires:  python3-mccabe
BuildRequires:  python3-platformdirs
BuildRequires:  python3-pytest
BuildRequires:  python3-pytest-runner
BuildRequires:  python3-tomlkit
BuildRequires:  python3-typing-extensions

Requires:       python3-%{name} = %{version}-%{release}

%global _description %{expand:
Pylint is a Python source code analyzer which looks for programming errors,
helps enforcing a coding standard and sniffs for some code smells (as defined in
Martin Fowler's Refactoring book). Pylint can be seen as another PyChecker since
nearly all tests you can do with PyChecker can also be done with Pylint.
However, Pylint offers some more features, like checking length of lines of
code, checking if variable names are well-formed according to your coding
standard, or checking if declared interfaces are truly implemented, and much
more.

Additionally, it is possible to write plugins to add your own checks.}

%description %_description

%package -n python3-%{name}
Summary:        %{summary}
Requires:       python3-setuptools
Requires:       python3-astroid >= 2.12.1
Requires:       python3-dill
Requires:       python3-mccabe
Requires:       python3-platformdirs
Requires:       python3-isort
Requires:       python3-tomlkit

%description -n python3-%{name} %_description

%prep
%autosetup -p1

%build
%pyproject_wheel

%install
%pyproject_install
rm -rf %{buildroot}%{python3_sitelib}/pylint/test

for NAME in epylint pylint pyreverse symilar; do
    mv %{buildroot}%{_bindir}/{$NAME,${NAME}-%{python3_version}}
    ln -s ${NAME}-%{python3_version} %{buildroot}%{_bindir}/${NAME}-3
    ln -s ${NAME}-%{python3_version} %{buildroot}%{_bindir}/${NAME}
done


%files
%doc CONTRIBUTORS.txt
%license LICENSE
%{_bindir}/epylint
%{_bindir}/pylint
%{_bindir}/pylint-config
%{_bindir}/pyreverse
%{_bindir}/symilar

%files -n python3-%{name}
%license LICENSE
%{python3_sitelib}/pylint*
%{_bindir}/*-3
%{_bindir}/*-%{python3_version}

%changelog
* Wed Jun 11 2025 bbrucezhang <bbrucezhang@tencent.com> - 2.17.4-2
- Rebuilt for loongarch64

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.17.4-1
- initial build
